# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
import typing_extensions
from ..core.pydantic_utilities import IS_PYDANTIC_V2
from ..core.serialization import FieldMetadata
from ..core.unchecked_base_model import UncheckedBaseModel
from .parse_config_chunking_strategy_type import ParseConfigChunkingStrategyType


class ParseConfigChunkingStrategy(UncheckedBaseModel):
    """
    Strategy for dividing the document into chunks.
    """

    type: typing.Optional[ParseConfigChunkingStrategyType] = pydantic.Field(default=None)
    """
    The type of chunking strategy. Supported values:
    
    * `page`: Chunk document by pages.
    * `document`: Entire document is a single chunk. Essentially no chunking.
    * `section`: Split by logical sections. Not supported for target=spatial.
    """

    min_characters: typing_extensions.Annotated[typing.Optional[int], FieldMetadata(alias="minCharacters")] = (
        pydantic.Field(default=None)
    )
    """
    Specify a minimum number of characters per chunk.
    """

    max_characters: typing_extensions.Annotated[typing.Optional[int], FieldMetadata(alias="maxCharacters")] = (
        pydantic.Field(default=None)
    )
    """
    Specify a maximum number of characters per chunk.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
